<?php

function cth_eventres_stripe_event_listener() {
 
	if(isset($_GET['eventres-listener']) && $_GET['eventres-listener'] == 'stripe') {
 
		global $gather_stripe_options;
 
		require_once CTH_EVENTRES_DIR .'includes/stripe-php/init.php';

		if( !defined('STRIPE_LOG_FILE') ) define("STRIPE_LOG_FILE", "./stripe.log");

		if(isset($gather_stripe_options['stripe_test_mode']) && $gather_stripe_options['stripe_test_mode']) {
			$secret_key = $gather_stripe_options['test_secret_key'];
			if( !defined('STRIPE_DEBUG') ) define("STRIPE_DEBUG", true);
		} else {
			$secret_key = $gather_stripe_options['live_secret_key'];
			if( !defined('STRIPE_DEBUG') ) define("STRIPE_DEBUG", false);
		}
		// Use Stripe's library to make requests...
		\Stripe\Stripe::setApiKey( $secret_key );

		// Retrieve the request's body and parse it as JSON
		$input = @file_get_contents("php://input");
		$event_json = json_decode($input);

		//sender email: 
		$sender_option = isset($gather_stripe_options['email_sender_name']) ? $gather_stripe_options['email_sender_name'] : 'Gather Event';
	    $sender_email_option = isset($gather_stripe_options['email_sender_email']) ? $gather_stripe_options['email_sender_email'] : 'no-reply@cththemes.com';

	    $eventres_add_fields  = isset( $gather_stripe_options['add_fields'] ) ? $gather_stripe_options['add_fields'] : array();

	    $first_name = __('First name','cth-gather-plugins');
		$last_name = __('Last name','cth-gather-plugins');
 
		if(isset($event_json->id)) {

 
			try {
 
				// Verify the event by fetching it from Stripe
				$event = \Stripe\Event::retrieve($event_json->id);
				// echo'<pre>';
				// var_dump($event);
				// Do something with $event

				$eventdataobj = $event->data->object;

				if(isset($eventdataobj->metadata['res_id'])){

					if(STRIPE_DEBUG){
						

						// ob_start();

						// var_dump($eventdataobj);

						// $event_out = ob_get_clean();

						// error_log(date('[Y-m-d H:i e] '). "Event type: " . $event->type . PHP_EOL . "Event data object: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);
						error_log(date('[Y-m-d H:i e] '). "Event type: " . $event->type . PHP_EOL , 3, STRIPE_LOG_FILE);

					} 

					// successful payment
					if($event->type == 'charge.succeeded') {
						// send a payment receipt email here

						//do nothing on subscription charge:
						if(isset($eventdataobj->invoice) && $eventdataobj->invoice ) return ;

						//update registration status:
						if(isset($eventdataobj->metadata['res_id'])){
							$res_id = $eventdataobj->metadata['res_id'] ;
							if(!update_post_meta( $res_id, 'pur_status', 'Completed')){
								if(STRIPE_DEBUG) {	
									error_log(date('[Y-m-d H:i e] '). "Can not update pur_status to Completed.". PHP_EOL, 3, LOG_FILE);
								}
							}
						}

						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "Succeeded emails ". PHP_EOL, 3, LOG_FILE);
						}

						$customer = \Stripe\Customer::retrieve($eventdataobj->customer);
						$email = $customer->email;

						$payer_email = $customer->email;
						$payment_id = $eventdataobj->id;

						if(isset( $customer->metadata['first_name'] ) ){
							$first_name = $customer->metadata['first_name'];
						}
	 					
	 					if(isset( $customer->metadata['last_name'])){
							$last_name = $customer->metadata['last_name'];
						}
						
		            	//new in version 2
		            	$allow_field_names = array('first_name','last_name','payer_email','event_pass','quantity','payment_id','txn_id','invoice_currency','invoice_amount','invoice_date','sitename');
					    
					    // if(!empty($eventres_add_fields)){
					    //     foreach ($eventres_add_fields as $key => $field) {
					    //         $field_name = str_replace(array(" ","-"), "_", $field['name']);
					    //         $allow_field_names[] = $field_name;
					    //         if(!isset($$field_name)){
					    //             $$field_name = get_post_meta( $res_id, $field_name, true );
					    //         }
					    //     }
					    // }

					    //extract template variables from charge metadata
					    if(isset($eventdataobj->metadata) && count($eventdataobj->metadata)) {
					    	// ob_start();
					    	// var_dump($eventdataobj->metadata);
					    	// var_dump($eventdataobj->metadata->__toArray());
					    	// var_dump($eventdataobj->metadata->__toArray(true));
					    	// $out = ob_get_clean();
					    	// error_log(date('[Y-m-d H:i e] '). "Email charge.succeeded sent failed" .$out. PHP_EOL, 3, STRIPE_LOG_FILE);
					    	foreach ($eventdataobj->metadata->__toArray() as $key => $field) {
					            $field_name = str_replace(array(" ","-"), "_", $key);
					            $allow_field_names[] = $field_name;
					            if(!isset($$field_name)){
					                $$field_name = $field ;
					            }

					            // error_log(date('[Y-m-d H:i e] '). "Field: " .$field_name. PHP_EOL, 3, STRIPE_LOG_FILE);
					            // error_log(date('[Y-m-d H:i e] '). "Value: " .$$field_name. PHP_EOL, 3, STRIPE_LOG_FILE);
					        }
					    }

					    $allow_field_names = array_unique($allow_field_names);

					    $invoice_amount = number_format($eventdataobj->amount / 100, 2, '.',',');
		            	$invoice_currency = $eventdataobj->currency;
		            	$txn_id = $eventdataobj->balance_transaction;
		            	$sitename 			= get_option( 'blogname' );
		            	$invoice_date = date(get_option('date_format' ). ' H:i:s', $eventdataobj->created);

		            	if($gather_stripe_options['success_to_buyer_email'] === 'yes') :
			            	// to buyer
			            	// if(get_post_meta( $res_id, 'pur_email', true ) == FALSE){
			            	// 	$buyer_mail_to = $payer_email;
			            	// }else{
			            	// 	$buyer_mail_to = get_post_meta( $res_id, 'pur_email', true );
			            	// }
			            	//$buyer_mail_to = $mail;
			            	/*email template variables*/
			            	
			            	

			            	$success_to_buyer_email_subject = $gather_stripe_options['success_to_buyer_email_subject']; 
							$success_to_buyer_email_template = $gather_stripe_options['success_to_buyer_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $success_to_buyer_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $success_to_buyer_email_template = preg_replace($fieldsPattern, $fieldsReplace, $success_to_buyer_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                //$success_to_admin_email_emails = isset($gather_stripe_options['success_to_admin_email_emails']) ? $gather_stripe_options['success_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                //$success_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($success_to_admin_email_emails) );
		                	wp_mail( $payer_email, $success_to_buyer_email_subject , $success_to_buyer_email_template , $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;

		            	if($gather_stripe_options['success_to_admin_email'] === 'yes') :
			            	// to buyer
			            	// if(get_post_meta( $res_id, 'pur_email', true ) == FALSE){
			            	// 	$buyer_mail_to = $payer_email;
			            	// }else{
			            	// 	$buyer_mail_to = get_post_meta( $res_id, 'pur_email', true );
			            	// }
			            	//$buyer_mail_to = $mail;
			            	/*email template variables*/
			            	// $invoice_amount = number_format($eventdataobj->amount / 100, 2, '.',',');
			            	// $invoice_currency = $eventdataobj->currency;
			            	// $txn_id = $eventdataobj->balance_transaction;
			            	// $sitename 			= get_option( 'blogname' );
			            	// $invoice_date = date(get_option('date_format' ), $eventdataobj->created);
			            	

			            	$success_to_admin_email_subject = $gather_stripe_options['success_to_admin_email_subject']; 
							$success_to_admin_email_template = $gather_stripe_options['success_to_admin_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $success_to_admin_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $success_to_admin_email_template = preg_replace($fieldsPattern, $fieldsReplace, $success_to_admin_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                $success_to_admin_email_emails = isset($gather_stripe_options['success_to_admin_email_emails']) ? $gather_stripe_options['success_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                $success_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($success_to_admin_email_emails) );
		                	wp_mail( array_filter($success_to_admin_email_emails,'trim'), $success_to_admin_email_subject , $success_to_admin_email_template , $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;




	 
						// retrieve the payer's information

						
						// $amount = $eventdataobj->amount / 100; // amount comes in as amount in cents, so we need to convert to dollars
	 
						// $subject = __('Payment Receipt', 'cth-gather-plugins');
						// $headers = 'From: "' . html_entity_decode(get_bloginfo('name')) . '" <' . get_bloginfo('admin_email') . '>';
						// $message = "Hello " . $customer_name . "\n\n";
						// $message .= "You have successfully made a payment of " . $amount . "\n\n";
						// $message .= "Thank you.";
	 
						// $mail_sent =  wp_mail($email, $subject, $message, $headers);
						// if(!$mail_sent && STRIPE_DEBUG){
						// 	error_log(date('[Y-m-d H:i e] '). "Email charge.succeeded sent failed" . PHP_EOL, 3, STRIPE_LOG_FILE);
						// }
					}
					// failed payment
					if($event->type == 'charge.failed') {
						// send a failed payment notice email here

						//do nothing on subscription charge:
						if(isset($eventdataobj->invoice) && $eventdataobj->invoice ) return ;



						//update registration status:
						if(isset($eventdataobj->metadata['res_id'])){
							$res_id = $eventdataobj->metadata['res_id'] ;
							if(!update_post_meta( $res_id, 'pur_status', 'Failed')){
								if(STRIPE_DEBUG) {	
									error_log(date('[Y-m-d H:i e] '). "Can not update pur_status to Failed.". PHP_EOL, 3, LOG_FILE);
								}
							}
							
						}

						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "Failed emails ". PHP_EOL, 3, LOG_FILE);
						}
	 
						$customer = \Stripe\Customer::retrieve($eventdataobj->customer);
						// $email = $customer->email;

						$payer_email = $customer->email;
						$payment_id = $eventdataobj->id;

						

						if(isset( $customer->metadata['first_name'] ) ){
							$first_name = $customer->metadata['first_name'];
						}
	 					
	 					if(isset( $customer->metadata['last_name'])){
							$last_name = $customer->metadata['last_name'];
						}
						
		            	//new in version 2
		            	$allow_field_names = array('first_name','last_name','payer_email','event_pass','quantity','payment_id','txn_id','invoice_currency','invoice_amount','invoice_date','sitename');

					    //extract template variables from charge metadata
					    if(isset($eventdataobj->metadata) && count($eventdataobj->metadata)) {
					    	foreach ($eventdataobj->metadata->__toArray() as $key => $field) {
					            $field_name = str_replace(array(" ","-"), "_", $key);
					            $allow_field_names[] = $field_name;
					            if(!isset($$field_name)){
					                $$field_name = $field ;
					            }
					        }
					    }

					    $allow_field_names = array_unique($allow_field_names);

					    /*email template variables*/
		            	$invoice_amount = number_format($eventdataobj->amount / 100, 2, '.',',');
		            	$invoice_currency = $eventdataobj->currency;
		            	$txn_id = $eventdataobj->balance_transaction;
		            	$sitename 			= get_option( 'blogname' );
		            	$invoice_date = date(get_option('date_format' ). ' H:i:s', $eventdataobj->created);


		            	if($gather_stripe_options['failed_to_buyer_email'] === 'yes') :
			            	
			            	

			            	$failed_to_buyer_email_subject = $gather_stripe_options['failed_to_buyer_email_subject']; 
							$failed_to_buyer_email_template = $gather_stripe_options['failed_to_buyer_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $failed_to_buyer_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $failed_to_buyer_email_template = preg_replace($fieldsPattern, $fieldsReplace, $failed_to_buyer_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                // $failed_to_admin_email_emails = isset($gather_stripe_options['failed_to_admin_email_emails']) ? $gather_stripe_options['failed_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                // $failed_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($failed_to_admin_email_emails) );
		                	wp_mail( $payer_email , $failed_to_buyer_email_subject , $failed_to_buyer_email_template, $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;


		            	if($gather_stripe_options['failed_to_admin_email'] === 'yes') :
			            	
			            	

			            	$failed_to_admin_email_subject = $gather_stripe_options['failed_to_admin_email_subject']; 
							$failed_to_admin_email_template = $gather_stripe_options['failed_to_admin_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $failed_to_admin_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $failed_to_admin_email_template = preg_replace($fieldsPattern, $fieldsReplace, $failed_to_admin_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                $failed_to_admin_email_emails = isset($gather_stripe_options['failed_to_admin_email_emails']) ? $gather_stripe_options['failed_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                $failed_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($failed_to_admin_email_emails) );
		                	wp_mail( array_filter($failed_to_admin_email_emails,'trim'), $failed_to_admin_email_subject , $failed_to_admin_email_template, $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;
					}

					//subscription created
					if($event->type == 'customer.subscription.created'){
						//update subscription status:
						if(isset($eventdataobj->metadata['res_id'])){
							$res_id = $eventdataobj->metadata['res_id'] ;
							if(!update_post_meta( $res_id, 'pur_status', $eventdataobj->status )){
								if(STRIPE_DEBUG) {	
									error_log(date('[Y-m-d H:i e] '). "Can not update pur_status to " . $eventdataobj->status .'.'. PHP_EOL, 3, LOG_FILE);
								}
							}
							if(isset($eventdataobj->discount) && $eventdataobj->discount ){
								if(!update_post_meta( $res_id, 'pur_discount_text', $eventdataobj->discount ) ){
									if(STRIPE_DEBUG) {	
										error_log(date('[Y-m-d H:i e] '). "Can not update pur_discount_text meta data" . PHP_EOL, 3, LOG_FILE);
									}
								}
							}
							
							
						}

						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "customer.subscription.created emails ". PHP_EOL, 3, LOG_FILE);
						}
					}


					//update subscription when end trial
					if($event->type == 'customer.subscription.updated'){
						//update subscription status:
						if(isset($eventdataobj->metadata['res_id'])){
							$res_id = $eventdataobj->metadata['res_id'] ;
							if(!update_post_meta( $res_id, 'pur_status', $eventdataobj->status )){
								if(STRIPE_DEBUG) {	
									error_log(date('[Y-m-d H:i e] '). "Can not update pur_status to " . $eventdataobj->status .'.'. PHP_EOL, 3, LOG_FILE);
								}
							}
							
						}

						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "customer.subscription.updated emails ". PHP_EOL, 3, LOG_FILE);
						}

						if(STRIPE_DEBUG){
						

							ob_start();

							var_dump($eventdataobj);

							$event_out = ob_get_clean();

							//error_log(date('[Y-m-d H:i e] '). "Event type: " . $event->type . PHP_EOL .'Subscription status: ' . $eventdataobj->status . PHP_EOL . "Event data object: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);
							error_log(date('[Y-m-d H:i e] '). "Event type: " . $event->type . PHP_EOL .'Subscription status: ' . $eventdataobj->status . PHP_EOL , 3, STRIPE_LOG_FILE);

						} 

					}

					//update subscription when end trial
					if($event->type == 'customer.subscription.trial_will_end'){
						//update subscription status:
						if(isset($eventdataobj->metadata['res_id'])){
							$res_id = $eventdataobj->metadata['res_id'] ;
							// if(!update_post_meta( $res_id, 'pur_status', $eventdataobj->status )){
							// 	if(STRIPE_DEBUG) {	
							// 		error_log(date('[Y-m-d H:i e] '). "Can not update pur_status to " . $eventdataobj->status .'.'. PHP_EOL, 3, LOG_FILE);
							// 	}
							// }

							do_action( 'gather_subscription_trial_will_end', $res_id, $eventdataobj );
							
						}

						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "customer.subscription.trial_will_end emails ". PHP_EOL, 3, LOG_FILE);
						}

						// if(STRIPE_DEBUG){
						

						// 	ob_start();

						// 	var_dump($eventdataobj);

						// 	$event_out = ob_get_clean();

						// 	//error_log(date('[Y-m-d H:i e] '). "Event type: " . $event->type . PHP_EOL .'Subscription status: ' . $eventdataobj->status . PHP_EOL . "Event data object: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);
						// 	error_log(date('[Y-m-d H:i e] '). "Event type: " . $event->type . PHP_EOL .'Subscription status: ' . $eventdataobj->status . PHP_EOL , 3, STRIPE_LOG_FILE);

						// } 

					}


					//subscription payment succeeded
					if($event->type == 'invoice.payment_succeeded'){
						//new in version 2
		            	$allow_field_names = array('first_name','last_name','payer_email','event_pass','quantity','invoice_id','invoice_currency','invoice_total','invoice_date','sub_id','sitename','plan_id','plan_name','plan_price','plan_currency','plan_interval');

						//update subscription post type
						if(isset($eventdataobj->subscription)){
							$subscription = \Stripe\Subscription::retrieve($eventdataobj->subscription);
							if(isset($subscription->metadata['res_id'])){
								$res_id = $subscription->metadata['res_id'] ;

								if(!update_post_meta( $res_id, 'current_period_start', $subscription->current_period_start )){
									if(STRIPE_DEBUG) {	
										error_log(date('[Y-m-d H:i e] '). "Can not update current_period_start to " . $subscription->current_period_start .'.'. PHP_EOL, 3, LOG_FILE);
									}
								}

								if(!update_post_meta( $res_id, 'current_period_end', $subscription->current_period_end )){
									if(STRIPE_DEBUG) {	
										error_log(date('[Y-m-d H:i e] '). "Can not update current_period_end to " . $subscription->current_period_end .'.'. PHP_EOL, 3, LOG_FILE);
									}
								}

								//subscription invoices
								$sub_invoices = get_post_meta( $res_id, 'sub_invoices', true );
								if(empty($sub_invoices)){
									//php 5.4+
									$sub_invoices = array( (object) array( 'date' => $eventdataobj->date, 'amount_due' => $eventdataobj->amount_due, 'subtotal' => $eventdataobj->subtotal, 'tax' => $eventdataobj->tax,'tax_percent' => $eventdataobj->tax_percent,'total' => $eventdataobj->total,'currency' => $eventdataobj->currency,'paid' => $eventdataobj->paid,'discount' => $eventdataobj->discount, 'closed' => $eventdataobj->closed , 'period_start' => $eventdataobj->period_start, 'period_end' => $eventdataobj->period_end ) );

									// ob_start();

									// var_dump($sub_invoices);

									// $event_out = ob_get_clean();

									// error_log(date('[Y-m-d H:i e] '). "Empty Invoices array: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);

								}else{
									array_unshift($sub_invoices, (object) array('date' => $eventdataobj->date, 'amount_due' => $eventdataobj->amount_due, 'subtotal' => $eventdataobj->subtotal, 'tax' => $eventdataobj->tax,'tax_percent' => $eventdataobj->tax_percent,'total' => $eventdataobj->total,'currency' => $eventdataobj->currency,'paid' => $eventdataobj->paid,'discount' => $eventdataobj->discount, 'closed' => $eventdataobj->closed , 'period_start' => $eventdataobj->period_start, 'period_end' => $eventdataobj->period_end ) );

									// ob_start();

									// var_dump($sub_invoices);

									// $event_out = ob_get_clean();

									// error_log(date('[Y-m-d H:i e] '). "Invoices array: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);
								}

								if(!update_post_meta( $res_id, 'sub_invoices', $sub_invoices  ) ){
									if(STRIPE_DEBUG) {	
										error_log(date('[Y-m-d H:i e] '). "Can not update sub_invoices " . PHP_EOL, 3, LOG_FILE);
									}
								}

							}

							//extract template variables from subscription metadata
						    if(isset($subscription->metadata) && count($subscription->metadata)) {
						    	foreach ($subscription->metadata->__toArray() as $key => $field) {
						            $field_name = str_replace(array(" ","-"), "_", $key);
						            $allow_field_names[] = $field_name;
						            if(!isset($$field_name)){
						                $$field_name = $field ;
						            }
						        }
						    }

						    if($subscription->plan){
						    	$plan_id = $subscription->plan->id;
						    	$plan_name = $subscription->plan->name;
						    	$plan_price = number_format($subscription->plan->amount/100, 2 );
						    	$plan_currency = $subscription->plan->currency;
						    	$each_text = __(' each ','cth-gather-plugins');
						    	if($subscription->plan->interval == 'day' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Daily','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'day'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' days','cth-gather-plugins');
						    	}
						    	if($subscription->plan->interval == 'week' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Weekly','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'week'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' weeks','cth-gather-plugins');
						    	}
						    	if($subscription->plan->interval == 'month' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Monthly','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'month'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' months','cth-gather-plugins');
						    	}
						    	if($subscription->plan->interval == 'year' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Yearly','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'year'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' years','cth-gather-plugins');
						    	}

						    	$quantity = $subscription->quantity;
						    }

						}
						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "invoice.payment_succeeded emails ". PHP_EOL, 3, LOG_FILE);
						}

						$customer = \Stripe\Customer::retrieve($eventdataobj->customer);
						// $email = $customer->email;
						$payer_email = $customer->email;
						if(isset( $customer->metadata['first_name'] ) ){
							$first_name = $customer->metadata['first_name'];
						}
	 					
	 					if(isset( $customer->metadata['last_name'])){
							$last_name = $customer->metadata['last_name'];
						}

						$invoice_id = $eventdataobj->id;
						$invoice_date = date(get_option('date_format' ). ' H:i:s', $eventdataobj->date);
						$invoice_total = number_format( $eventdataobj->total/100 , 2);
						$invoice_currency = $eventdataobj->currency;
						if(isset($res_id)){
							$sub_id = $res_id;
						}
		            	
					    

					    $allow_field_names = array_unique($allow_field_names);



						if($gather_stripe_options['invoice_to_buyer_email'] === 'yes') :
			            	// to buyer
			            	// if(get_post_meta( $res_id, 'pur_email', true ) == FALSE){
			            	// 	$buyer_mail_to = $payer_email;
			            	// }else{
			            	// 	$buyer_mail_to = get_post_meta( $res_id, 'pur_email', true );
			            	// }
			            	//$buyer_mail_to = $mail;
			            	/*email template variables*/
			            	
			            	

			            	$invoice_to_buyer_email_subject = $gather_stripe_options['invoice_to_buyer_email_subject']; 
							$invoice_to_buyer_email_template = $gather_stripe_options['invoice_to_buyer_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $invoice_to_buyer_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $invoice_to_buyer_email_template = preg_replace($fieldsPattern, $fieldsReplace, $invoice_to_buyer_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                //$success_to_admin_email_emails = isset($gather_stripe_options['success_to_admin_email_emails']) ? $gather_stripe_options['success_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                //$success_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($success_to_admin_email_emails) );
		                	wp_mail( $payer_email, $invoice_to_buyer_email_subject , $invoice_to_buyer_email_template , $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;

		            	if($gather_stripe_options['invoice_to_admin_email'] === 'yes') :
			            	// to buyer
			            	// if(get_post_meta( $res_id, 'pur_email', true ) == FALSE){
			            	// 	$buyer_mail_to = $payer_email;
			            	// }else{
			            	// 	$buyer_mail_to = get_post_meta( $res_id, 'pur_email', true );
			            	// }
			            	//$buyer_mail_to = $mail;
			            	/*email template variables*/
			            	// $invoice_amount = number_format($eventdataobj->amount / 100, 2, '.',',');
			            	// $invoice_currency = $eventdataobj->currency;
			            	// $txn_id = $eventdataobj->balance_transaction;
			            	// $sitename 			= get_option( 'blogname' );
			            	// $invoice_date = date(get_option('date_format' ), $eventdataobj->created);
			            	

			            	$invoice_to_admin_email_subject = $gather_stripe_options['invoice_to_admin_email_subject']; 
							$invoice_to_admin_email_template = $gather_stripe_options['invoice_to_admin_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $invoice_to_admin_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $invoice_to_admin_email_template = preg_replace($fieldsPattern, $fieldsReplace, $invoice_to_admin_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                $invoice_to_admin_email_emails = isset($gather_stripe_options['invoice_to_admin_email_emails']) ? $gather_stripe_options['invoice_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                $invoice_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($invoice_to_admin_email_emails) );
		                	wp_mail( array_filter($invoice_to_admin_email_emails,'trim'), $invoice_to_admin_email_subject , $invoice_to_admin_email_template , $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;

					}
					
					//subscription payment failed
					if($event->type == 'invoice.payment_failed'){
						//new in version 2
		            	$allow_field_names = array('first_name','last_name','payer_email','event_pass','quantity','invoice_id','invoice_currency','invoice_total','invoice_date','sub_id','sitename','plan_id','plan_name','plan_price','plan_currency','plan_interval');

						//update subscription post type
						if(isset($eventdataobj->subscription)){
							$subscription = \Stripe\Subscription::retrieve($eventdataobj->subscription);
							if(isset($subscription->metadata['res_id'])){
								$res_id = $subscription->metadata['res_id'] ;

								// if(!update_post_meta( $res_id, 'current_period_start', $subscription->current_period_start )){
								// 	if(STRIPE_DEBUG) {	
								// 		error_log(date('[Y-m-d H:i e] '). "Can not update current_period_start to " . $subscription->current_period_start .'.'. PHP_EOL, 3, LOG_FILE);
								// 	}
								// }

								// if(!update_post_meta( $res_id, 'current_period_end', $subscription->current_period_end )){
								// 	if(STRIPE_DEBUG) {	
								// 		error_log(date('[Y-m-d H:i e] '). "Can not update current_period_end to " . $subscription->current_period_end .'.'. PHP_EOL, 3, LOG_FILE);
								// 	}
								// }

								//subscription invoices
								$sub_invoices = get_post_meta( $res_id, 'sub_invoices', true );
								if(empty($sub_invoices)){
									//php 5.4+
									$sub_invoices = array( (object) array( 'date' => $eventdataobj->date, 'amount_due' => $eventdataobj->amount_due, 'subtotal' => $eventdataobj->subtotal, 'tax' => $eventdataobj->tax,'tax_percent' => $eventdataobj->tax_percent,'total' => $eventdataobj->total,'currency' => $eventdataobj->currency,'paid' => $eventdataobj->paid,'discount' => $eventdataobj->discount, 'closed' => $eventdataobj->closed , 'period_start' => $eventdataobj->period_start, 'period_end' => $eventdataobj->period_end ) );

									// ob_start();

									// var_dump($sub_invoices);

									// $event_out = ob_get_clean();

									// error_log(date('[Y-m-d H:i e] '). "Empty Invoices array: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);

								}else{
									array_unshift($sub_invoices, (object) array('date' => $eventdataobj->date, 'amount_due' => $eventdataobj->amount_due, 'subtotal' => $eventdataobj->subtotal, 'tax' => $eventdataobj->tax,'tax_percent' => $eventdataobj->tax_percent,'total' => $eventdataobj->total,'currency' => $eventdataobj->currency,'paid' => $eventdataobj->paid,'discount' => $eventdataobj->discount, 'closed' => $eventdataobj->closed , 'period_start' => $eventdataobj->period_start, 'period_end' => $eventdataobj->period_end ) );

									// ob_start();

									// var_dump($sub_invoices);

									// $event_out = ob_get_clean();

									// error_log(date('[Y-m-d H:i e] '). "Invoices array: " . $event_out . PHP_EOL, 3, STRIPE_LOG_FILE);
								}

								if(!update_post_meta( $res_id, 'sub_invoices', $sub_invoices  ) ){
									if(STRIPE_DEBUG) {	
										error_log(date('[Y-m-d H:i e] '). "Can not update sub_invoices " . PHP_EOL, 3, LOG_FILE);
									}
								}

							}

							//extract template variables from subscription metadata
						    if(isset($subscription->metadata) && count($subscription->metadata)) {
						    	foreach ($subscription->metadata->__toArray() as $key => $field) {
						            $field_name = str_replace(array(" ","-"), "_", $key);
						            $allow_field_names[] = $field_name;
						            if(!isset($$field_name)){
						                $$field_name = $field ;
						            }
						        }
						    }

						    if($subscription->plan){
						    	$plan_id = $subscription->plan->id;
						    	$plan_name = $subscription->plan->name;
						    	$plan_price = number_format($subscription->plan->amount/100, 2 );
						    	$plan_currency = $subscription->plan->currency;
						    	$each_text = __(' each ','cth-gather-plugins');
						    	if($subscription->plan->interval == 'day' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Daily','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'day'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' days','cth-gather-plugins');
						    	}
						    	if($subscription->plan->interval == 'week' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Weekly','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'week'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' weeks','cth-gather-plugins');
						    	}
						    	if($subscription->plan->interval == 'month' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Monthly','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'month'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' months','cth-gather-plugins');
						    	}
						    	if($subscription->plan->interval == 'year' && $subscription->plan->interval_count == 1){
						    		$plan_interval = __('Yearly','cth-gather-plugins');
						    	}elseif($subscription->plan->interval == 'year'){
						    		$plan_interval = $each_text . $subscription->plan->interval_count . __(' years','cth-gather-plugins');
						    	}

						    	$quantity = $subscription->quantity;
						    }

						}
						if(STRIPE_DEBUG) {	
							error_log(date('[Y-m-d H:i e] '). "invoice.payment_failed emails ". PHP_EOL, 3, LOG_FILE);
						}

						$customer = \Stripe\Customer::retrieve($eventdataobj->customer);
						// $email = $customer->email;
						$payer_email = $customer->email;
						if(isset( $customer->metadata['first_name'] ) ){
							$first_name = $customer->metadata['first_name'];
						}
	 					
	 					if(isset( $customer->metadata['last_name'])){
							$last_name = $customer->metadata['last_name'];
						}

						$invoice_id = $eventdataobj->id;
						$invoice_date = date(get_option('date_format' ). ' H:i:s', $eventdataobj->date);
						$invoice_total = number_format( $eventdataobj->total/100 , 2);
						$invoice_currency = $eventdataobj->currency;
						if(isset($res_id)){
							$sub_id = $res_id;
						}
		            	
					    

					    $allow_field_names = array_unique($allow_field_names);



						if($gather_stripe_options['invoice_failed_to_buyer_email'] === 'yes') :
			            	// to buyer
			            	// if(get_post_meta( $res_id, 'pur_email', true ) == FALSE){
			            	// 	$buyer_mail_to = $payer_email;
			            	// }else{
			            	// 	$buyer_mail_to = get_post_meta( $res_id, 'pur_email', true );
			            	// }
			            	//$buyer_mail_to = $mail;
			            	/*email template variables*/
			            	
			            	

			            	$invoice_failed_to_buyer_email_subject = $gather_stripe_options['invoice_failed_to_buyer_email_subject']; 
							$invoice_failed_to_buyer_email_template = $gather_stripe_options['invoice_failed_to_buyer_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $invoice_failed_to_buyer_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $invoice_failed_to_buyer_email_template = preg_replace($fieldsPattern, $fieldsReplace, $invoice_failed_to_buyer_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                //$success_to_admin_email_emails = isset($gather_stripe_options['success_to_admin_email_emails']) ? $gather_stripe_options['success_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                //$success_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($success_to_admin_email_emails) );
		                	wp_mail( $payer_email, $invoice_failed_to_buyer_email_subject , $invoice_failed_to_buyer_email_template , $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;

		            	if($gather_stripe_options['invoice_failed_to_admin_email'] === 'yes') :
			            	// to buyer
			            	// if(get_post_meta( $res_id, 'pur_email', true ) == FALSE){
			            	// 	$buyer_mail_to = $payer_email;
			            	// }else{
			            	// 	$buyer_mail_to = get_post_meta( $res_id, 'pur_email', true );
			            	// }
			            	//$buyer_mail_to = $mail;
			            	/*email template variables*/
			            	// $invoice_amount = number_format($eventdataobj->amount / 100, 2, '.',',');
			            	// $invoice_currency = $eventdataobj->currency;
			            	// $txn_id = $eventdataobj->balance_transaction;
			            	// $sitename 			= get_option( 'blogname' );
			            	// $invoice_date = date(get_option('date_format' ), $eventdataobj->created);
			            	

			            	$invoice_failed_to_admin_email_subject = $gather_stripe_options['invoice_failed_to_admin_email_subject'].' payment_failed'; 
							$invoice_failed_to_admin_email_template = $gather_stripe_options['invoice_failed_to_admin_email_template']; 

			                if(preg_match_all("/{([\w-_]+)[^\w-_]*}/", $invoice_failed_to_admin_email_template, $matches)!= FALSE){
			                    $fieldsPattern = array();//$matches[0];
			                    $fieldsReplace = array();
			                    foreach ($matches[1] as $key => $fn) {
			                        $fieldsPattern[] = "/{(".$fn.")[^\w-_]*}/";

			                        if( isset($$fn) && in_array($fn, $allow_field_names ) ){
			                        	$fieldsReplace[] = $$fn;  //'['.$fn.']';
			                        }else{
			                        	$fieldsReplace[] = '{'.$fn.'}';
			                        }

			                        
			                    }


			                    $invoice_failed_to_admin_email_template = preg_replace($fieldsPattern, $fieldsReplace, $invoice_failed_to_admin_email_template);
			                }


			                $headers = array();
			                if($gather_stripe_options['email_content_type'] == 'html'){
			                    $headers[] = 'Content-Type: text/html; charset=UTF-8';
			                }
			                //$headers[] = 'From: '. $sender_option.' ' . '<'.$sender_email_option.'>';
			                add_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			                add_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			                $headers[] = 'Reply-To: '. $sender_option.' ' . '<'.$sender_email_option.'>';

			                //$e_return = wp_mail( $mail_to, $mail_subject , $message, $headers);
			                //wp_mail( $buyer_mail_to, $buyer_mail_subject , $to_buyer_email_template, $headers);

			                $invoice_failed_to_admin_email_emails = isset($gather_stripe_options['invoice_failed_to_admin_email_emails']) ? $gather_stripe_options['invoice_failed_to_admin_email_emails'] : 'no-reply@cththemes.com';

			                $invoice_failed_to_admin_email_emails = preg_split( '/\r\n|\r|\n/', trim($invoice_failed_to_admin_email_emails) );
		                	wp_mail( array_filter($invoice_failed_to_admin_email_emails,'trim'), $invoice_failed_to_admin_email_subject , $invoice_failed_to_admin_email_template , $headers);
		                
			              	
			              	remove_filter( 'wp_mail_from_name', 'cth_gather_plugins_striperes_custom_wp_mail_from_name' );
			              	remove_filter('wp_mail_from', 'cth_gather_plugins_striperes_custom_wp_mail_from');

			            endif;

					}

					//subscription canceled event
					if($event->type == 'customer.subscription.deleted'){
						//delete subscription post type
						if(isset($eventdataobj->metadata['res_id'])){
							$res_id = $eventdataobj->metadata['res_id'];
							//wp_delete_post( $res_id , true );
							wp_trash_post($res_id);
							if(STRIPE_DEBUG) error_log(date('[Y-m-d H:i e] '). "Subscription post deleted: " . $res_id . PHP_EOL, 3, STRIPE_LOG_FILE);
							

						}
					}
 				}
			} catch (Exception $e) {
				// something failed, perhaps log a notice or email the site admin
				//wp_die('There is an error on Stripe event processing.','Error' );
				if(STRIPE_DEBUG) error_log(date('[Y-m-d H:i e] '). "Email sent failed" . $e->getMessage() . PHP_EOL, 3, STRIPE_LOG_FILE);

			}

		}

		http_response_code(200); // PHP 5.4 or greater
	}
}
add_action('init', 'cth_eventres_stripe_event_listener');

