<?php
/**
 * Shortcode attributes
 * @var $atts
 * @var $el_class
 * @var $form_title
 * @var $button_title
 * @var $layout
 * Shortcode class
 * @var $this WPBakeryShortCode_Cth_Paypal_Registration
 */
$el_class = $form_title = $button_title = $success_page = $layout = '';
$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );
//$eventres_multi_price         = get_option('eventres_multi_price','yes' );
$eventres_item_prices_name      = get_option('eventres_item_prices_name' );
$eventres_item_prices           = get_option('eventres_item_prices' );
$eventres_item_quantity_name    = get_option('eventres_item_quantity_name' );
$eventres_item_quantity         = get_option('eventres_item_quantity' );
$eventres_currency              = get_option('eventres_currency' );
$eventres_terms_content         = get_option('eventres_terms_content' );
$eventres_hide_terms            = get_option('eventres_hide_terms' );
$eventres_use_coupon            = get_option('eventres_use_coupon','no');
$eventres_coupon_message            = get_option('eventres_coupon_message','');


$eventres_test_mode = get_option('eventres_test_mode' );
if ($eventres_test_mode == true) {
    $paypal_url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
}else{
    $paypal_url = 'https://www.paypal.com/cgi-bin/webscr';
}

// new in version 2
$eventres_add_fields            = get_option('eventres_add_fields','' );

$ajax_datas = array(
    'url'           => admin_url( 'admin-ajax.php' ),
    'msg_fname'     => get_option('eventres_message_empty_fname' ),
    'msg_lname'     => get_option('eventres_message_empty_lname' ),
    'msg_email'     => get_option('eventres_message_empty_email' ),
    'msg_pass'     => get_option('eventres_message_empty_pass' ),
    'msg_seats'     => get_option('eventres_message_empty_seats' ),
    'msg_agree'     => get_option('eventres_message_empty_agree' ),
    'msg_wait'     => __('Please wait...','cth-gather-plugins'),
);
if(!empty($eventres_add_fields)){
    $ajax_datas['add_fields_validate'] = array();
    foreach ($eventres_add_fields as $key => $add_field) {
        $field_name = str_replace(array(" ","-"), "_", $add_field['name']);
        // echo'<pre>';var_dump($add_field['required']);
        if(isset($add_field['required'])&& $add_field['required'] == 'true'){
            $ajax_datas['add_fields_validate'][$field_name] = "required";
        }
        
    }
}

//echo'<pre>';var_dump($eventres_item_quantity);die;
wp_enqueue_script("eventpaypalres-js", CTH_EVENTRES_DIR_URL . "assets/js/eventpaypalres.min.js", array('jquery','gather-validate-js'), false, true);
//Main Ajax script 
wp_localize_script( 'eventpaypalres-js', 'eventres_ajax', $ajax_datas );
// new in version 2.6
$use_limit = false;
$reg_limit = get_option('eventres_reg_paypal_limit','');
if( $reg_limit !== '' && is_numeric( $reg_limit) && $reg_limit >= 0 ) {
    $use_limit = true;
}
?>
<?php if($layout == 'modal') :?>
<!-- 
 Registration Popup (PAYPAL)
 ====================================== -->
<div class="modal fade register-modal" id="register-now" tabindex="-1" role="dialog" aria-labelledby="register-now-label">
    <div class="modal-dialog modal-sm" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title text-center" id="register-now-label"><?php echo esc_attr($form_title );?></h4>
            </div>
            <div class="modal-body">
<?php endif;?>
                <div class="registration-form <?php echo esc_attr($el_class );?>">
                <?php if($layout == 'normal') :?>
                    <h4 class="modal-title text-center" id="register-now-label"><?php echo esc_attr($form_title );?></h4>
                <?php endif;?>
                    <?php if(!empty($content)){
                        echo wpb_js_remove_wpautop($content);
                    }?>
                <?php
                if($use_limit && $reg_limit > 0 || !$use_limit ) : ?>
                    <form action="<?php echo esc_url($paypal_url );?>" method="POST" target="_top" id="paypal-regn">
                        
                        <div id="eventreg_msg"></div>
                        
                        <?php
                            // to make our script safe, it's a best practice to use nonce on our form to check things out
                            if ( function_exists( 'wp_nonce_field' ) ) 
                                wp_nonce_field( 'gather_event_paypal_registration_action', 'gather_event_paypal_registration_nonce' );
                        ?>
                        <div class="row">
                            <div class="col-sm-6">
                                <div class="form-group">
                                    <label><?php _e('First Name','cth-gather-plugins');?></label>
                                    <input type="text" class="form-control" name="first_name" placeholder="<?php _e('First Name','cth-gather-plugins');?>" required>
                                </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="form-group">
                                    <label><?php _e('Last Name','cth-gather-plugins');?></label>
                                    <input type="text" class="form-control" name="last_name" placeholder="<?php _e('Last Name','cth-gather-plugins');?>" required>
                                </div>
                            </div>
                        </div>
                        <!-- <div class="form-group">
                            <label>Username</label>
                            <input type="text" class="form-control" name="log" placeholder="Username">
                        </div> -->
                        <div class="form-group">
                            <label><?php _e('Email Address','cth-gather-plugins');?></label>
                            <input type="email" class="form-control" name="email" placeholder="<?php _e('Email Address','cth-gather-plugins');?>" required>
                        </div>

                        <?php if(!empty($eventres_add_fields)){
                            foreach ($eventres_add_fields as $key => $add_field) {
                                ?>
                                <div class="form-group">
                                    
                                <?php if($add_field['type'] == 'text'):?>
                                    <label><?php echo $add_field['label'];?></label>
                                    <input type="text" class="form-control" name="<?php echo str_replace(array(" ","-"), "_", $add_field['name']);?>" value="<?php echo $add_field['value'];?>" placeholder="<?php echo $add_field['label'];?>">
                                <?php elseif($add_field['type'] =='textarea'):?>
                                    <label><?php echo $add_field['label'];?></label>
                                    <textarea class="form-control" name="<?php echo str_replace(array(" ","-"), "_", $add_field['name']);?>" placeholder="<?php echo $add_field['label'];?>"><?php echo $add_field['value'];?></textarea>
                                <?php elseif($add_field['type'] =='select'&&!empty($add_field['value'])):?>
                                    <label><?php echo $add_field['label'];?></label>
                                    <select class="form-control" name="<?php echo str_replace(array(" ","-"), "_", $add_field['name']);?>">
                                        <?php foreach ($add_field['value'] as $key => $f_ops) {
                                            echo '<option value="'.esc_attr($f_ops['value'] ).'">'.esc_attr($f_ops['name'] ).'</option>';
                                        } ?>
                                    </select>
                                <?php endif;?>
                                </div>
                        <?php
                            }
                        } ?>

                        <div class="row">
                            <div class="col-sm-7">
                                <div class="form-group">
                                    <label><?php echo __('Choose a ','cth-gather-plugins') . esc_attr($eventres_item_prices_name );?></label>
                                    <?php if($eventres_item_prices && count($eventres_item_prices)): ?>
                                    <select class="form-control" name="os0" required>
                                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>
                                    <?php foreach ($eventres_item_prices as $value) { ?>
                                        <option value="<?php echo esc_attr($value['name'] );?>"><?php echo esc_attr($value['name'] ) .' - '. esc_attr($value['value'] ).' '.esc_attr( $eventres_currency );?></option>
                                    <?php } ?>
                                    </select>
                                    <?php else :?>
                                    <select class="form-control" name="os0" required>
                                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>
                                        <option value="Default Pass">Default Pass - 99 USD</option>
                                    </select>
                                    <?php endif;?>
                                </div>
                                <input type="hidden" name="on0" value="<?php echo !empty($eventres_item_prices_name)? esc_attr($eventres_item_prices_name ) : 'Pass';?>">  
                            </div>
                            
                            <div class="col-sm-5">
                                <div class="form-group">
                                    <label><?php echo esc_attr($eventres_item_quantity_name );?></label>
                                    <?php if($eventres_item_quantity && count($eventres_item_quantity)): ?>
                                    <select class="form-control" name="item_quantity" required>
                                        <option value=""><?php _e('Choose...','cth-gather-plugins');?></option>

                                    <?php 
                                    if($use_limit) : ?>
                                        <?php foreach ($eventres_item_quantity as $value) { ?>
                                            <?php 
                                            if($value['value'] <= $reg_limit) : ?>
                                            <option value="<?php echo esc_attr($value['value'] );?>"><?php echo esc_attr($value['name'] );?></option>
                                            <?php endif ; ?>
                                        <?php } ?>
                                    <?php else : ?>
                                        <?php foreach ($eventres_item_quantity as $value) { ?>
                                            <option value="<?php echo esc_attr($value['value'] );?>"><?php echo esc_attr($value['name'] );?></option>
                                        <?php } ?>
                                    <?php 
                                    endif; ?>
                                    
                                    </select>
                                    <?php else : ?>
                                    <input type="text" name="item_quantity" class="form-control" value="1">
                                    <?php endif;?>
                                </div>
                            </div>
                        </div>

                        <?php 
                        if($use_limit) : ?>
                        <div class="available-seats">
                            <?php
                                printf( _nx( '<p>Only <strong>%s</strong> seat is available</p>', '<p>Only <strong>%s</strong> seats are available</p>', (int) $reg_limit, 'paypal register', 'cth-gather-plugins' ), $reg_limit ) ;
                            ?>
                        </div>
                        <?php endif;?>

                        <?php if($eventres_use_coupon == 'yes') :

                            // new in version 2.6
                            $use_coupon_limit = false;
                            $coupon_limit = get_option('eventres_coupon_limit','');
                            if( $coupon_limit !== '' && is_numeric( $coupon_limit) && $coupon_limit >= 0 ) {
                                $use_coupon_limit = true;
                            }

                            if($use_coupon_limit && $coupon_limit > 0 || !$use_coupon_limit ) :
                        ?>
                        <div class="row">
                            
                            <div class="col-sm-12">
                                <div class="form-group">
                                    <?php if(!empty($eventres_coupon_message)) echo wp_kses_post( $eventres_coupon_message );?>
                                    <input type="text" class="form-control" id="coupon_code" name="coupon_code" placeholder="<?php _e('Coupon Code','cth-gather-plugins');?>">
                                    <div class="available-coupons">

                                    <?php
                                        if($use_coupon_limit) printf( _nx( '<p>Only <strong>%s</strong> coupon is available.</p>', '<p>Only <strong>%s</strong> coupons are available.</p>', (int) $coupon_limit, 'paypal coupon register', 'cth-gather-plugins' ), $coupon_limit ) ;
                                    ?>
                                    </div>
                                </div>
                            </div>

                        </div>
                            <?php else : ?>
                                <?php echo get_option('eventres_coupon_limit_msg','');?>
                            <?php endif; //end use coupon limit ?>
                        <?php
                        endif;?>

                        <div class="form-group">
                            <div class="checkbox">
                                <label>
                                <?php if($eventres_hide_terms == 'yes') :?>
                                    <input checked="checked" type="checkbox" name="agree" required style="display:none;">
                                <?php else :?>
                                    <input type="checkbox" name="agree" required>
                                <?php endif;?>
                                    <?php echo wp_kses_post( $eventres_terms_content );?>
                                </label>
                            </div>
                        </div>
                        
                        <div class="text-center top-space">
                            <button type="submit" id="reserve-btn" class="btn btn-success btn-lg"><?php echo esc_attr($button_title );?></button>
                            
                        </div>
                    </form>
                <?php  else : ?>

                    <?php echo get_option('eventres_paypal_sold_out','');?>

                <?php 
                endif; // end use limit
                ?>
                </div>
            <?php if($layout == 'modal') :?>
            </div>
        </div>
    </div>
</div>
<?php endif;?>
